/***************************************************************************
 *   Copyright (C) 2007 by Artur Szymiec   *
 *   artur.szymiec@gmail.com   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#ifndef KMatrix3D_H__
#define KMatrix3D_H__

//Definitions
#define	NBR_LIGNES_MAX_DEF 6000

#include <qgl.h> 
#include <sys/time.h>
#include <qslider.h>
#include "kscreensaver.h"
#include "kmatrix3dui.h"
#include "structures.h"
#include "ligne3d1.h"
#include "camera.h"
class mQGL : public QGLWidget
{
   Q_OBJECT
public:
    mQGL(int noOf3DLines);	
protected:
    //Global objects here
    int	NBR_LIGNES_MAX;
    infos_gen s_infos_gen;
    clock_t temps_1,temps_2,fps_1,fps_2;
    int fps_img_1,fps_img_2;
    int i,i2,i4,j4;
    double ordre_cour,fps_real;
    struct timeval r_time1,r_time2,r_time3;	
    //class "camera"
    camera *camera_1;
    //class "line3d"
    Ligne3D1 * ligne_1[NBR_LIGNES_MAX_DEF];
    int InitTextures();
    int LoadTexture(unsigned &texture_sz,char * filename);
    int timeval_subtract (struct timeval *result,struct timeval *x,struct timeval *y);
    void abort_(const char * s, ...);
    void initializeGL();
    void resizeGL(int width, int height);
    void paintGL();
    void timerEvent( QTimerEvent * );
    void sift_in(unsigned count, ordre_z *data, unsigned free, ordre_z next);
    void heapsort(unsigned count, ordre_z *data);
};

class KMatrix3D : public KScreenSaver
{
    Q_OBJECT
public:
    KMatrix3D( WId drawable );
    virtual ~KMatrix3D();
private:
    void readSettings();
    void blank();
    int config3dLines;
    mQGL *myGL;	
};

class KMatrix3DSetup : public KMatrix3DUI
{
    Q_OBJECT
public:
    KMatrix3DSetup( QWidget *parent = NULL, const char *name = NULL );

private slots:
    void slotOkPressed();
    void slotCancelPressed();

private:
    void readSettings();
    KMatrix3D *saver;
};




#endif
