/***************************************************************************
 *   Copyright (C) 2007 by Artur Szymiec                                   *
 *   artur.szymiec@gmail.com                                               *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************
 *                      Orginal Code & Idea by                             *
 *                          Thomas John                                    *
 *                      thomas.john@open-design.be                         *
 *                                                                         *
 *                Linux Port & Some Minor Changes by                       *
 *                         Artur Szymiec                                   *
 *                   artur.szymiec@gmail.com	                           *
 ***************************************************************************/

#ifndef LIGNE3D1_H
#define LIGNE3D1_H
#include "effet_particule.h"

/**
	@author Artur Szymiec <artur.szymiec@gmail.com>
*/
class Ligne3D1
	{

		// Private members (variables, functions...)
		private:

			struct Lettre3D1 {
				
				// position of the letter
				double pos_x;
				double pos_y;
				double pos_z;
				
				// state of the letter
				int	etat;
				
				// timer 1
				int	temps;
				int	temps_tot;
				
				// timer 2 (temps_tot_2 = time  to wait before change character if the letter can change in time
				int	temps_2;
				int	temps_tot_2;
				
				// character to display 56 characters in set
				// the int represents one position in table with texture cordinates
				int caractere;
				
				// opacity of the letter
				double opacite;

				// distance of the letter for raporting to camera distance
				double dist_tmp;

				// specyfies that the lettter can change down in time
				int change_sz;
				
			};

			// structure which hold information for each letter in line
			Lettre3D1* lettre_1;

			// number of current active letters
			int	m_nbr_actif;

			// time to wait before change to new letter
			int	m_temps_tot;
			int	m_temps;
			
			// pointer to structure which hold general info
			infos_gen * infos_gen_tmp;

			// index of the class
			int index_tmp;

			// man number of the letters per line
			int nbr_max_lettres;

			// number of letters displayed (set per collection)
			int decpt_nbr_lettres;
			
			//duration of the melting latter (in fact it hold duration of all letters in line)
			int m_temps_fondu;

			// specifies that the line use class "effet_particule"
			bool m_effet_particule;

			// effect particle is not active if speed of line (m_temps_tot) is rapid m_temps_tot<30
			//  when all letters finish their life line is re-initialized
			//  it is important do not charge a number of times for instance of class "effet_particule"
			
			// specyfies if one instance of the class "effet_particule" is charged
			bool m_charge_part;
	
			// declare the pointer to effect "effet_particule" class instance
			effet_particule * particules_1;

			// distance of the line by way of the cammera shuld have been able to utilise the speed
			// it's calculated for each and every letter in line
			// except certain effects later

			// distance of the line to camera to report
			double dist_tmp;

			// opacity of the line
			//double opacite_gen;

			// init of the one letter
			void init_lettre( int index_sz );
			// for calculation the clipping behind field of view
			double a1,a2;
			// calculated function given from the timer of each letter (temps and temps_tot)
        		double prct_sz;
			 // variables that allow us calculate the distance to camera
			double dist_x;
			double dist_y;
			double dist_z;
			//iterators
			int	i,i2,i3; 
		//public members
		public:
			
			// state of the class
			int m_etat;
			
			// line cordinates
			double m_x;
			double m_y;
			double m_z;

			// default constructor
			Ligne3D1( double x, double y, double z , struct infos_gen * , int index);

			// default destructor
			~Ligne3D1( );
			
			// calculate the state of the particles
			void calculer();

			// display elements
			void afficher();
			
	};

#endif
