/***************************************************************************
 *   Copyright (C) 2007 by Artur Szymiec                                   *
 *   artur.szymiec@gmail.com                                               *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************
 *                      Orginal Code & Idea by                             *
 *                          Thomas John                                    *
 *                      thomas.john@open-design.be                         *
 *                                                                         *
 *                Linux Port & Some Minor Changes by                       *
 *                         Artur Szymiec                                   *
 *                   artur.szymiec@gmail.com	                           *
 ***************************************************************************/

#ifndef STRUCTURES_H
#define STRUCTURES_H

#include <GL/gl.h>

// structure that holds informations about camera
struct infos_cam
{

        // class state
        int etat;

        // coordinates of the point on which camera looks (target)
        double m_x_t;
        double m_y_t;
        double m_z_t;

        // coordinates of the camera
        double m_x_v;
        double m_y_v;
        double m_z_v;

        // distance from target to camera
        double m_distance;

        // rotation degrees 
        double rot;

};

// structure which contain cordinates of the ligne3d
// this is necessary to know the order of the line in zbuffer
// cordinate in space to camera
struct ordre_z
{

        // inedex of class "ligne3d1"
        int index;

        // "z" cordinate
        double ordre;

};

// Information about texture cordinates
struct infos_tex_vertes
{

        float x1;
        float y1;

        float x2;
        float y2;

        float x3;
        float y3;

        float x4;
        float y4;

};

// Structure which will hold all the informations gathered together
struct infos_gen
{


        // white letters
        GLuint tex_lettres_blanches;

        // green letters
        GLuint tex_lettres_vertes;

        // particle
        GLuint tex_part_1;

        //Texture cordinates for 56 bizzare characters
        //
        infos_tex_vertes info_tex_vertes_sz[56];


        // temp value holding msec time taken to refresh scene
        int msec;

        // serving for debug purposes
        double dist_ttmp;

        //parameter to change different blending functions
        GLenum prem;
        GLenum deux;


        //List of Z cordinates for every Ligne3D
        ordre_z * ordre_sz;
	

        //Holds the information about camera
        infos_cam infos_cam_sz;

};

#endif

