/***************************************************************************
 *   Copyright (C) 2007 by Artur Szymiec   *
 *   artur.szymiec@gmail.com   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
/*Orinal By: Kevin Harris*/


#ifndef VECTOR3F_H
#define VECTOR3F_H

/**
	@author Artur Szymiec <artur.szymiec@gmail.com>
*/
class vector3f
{
public:
        double x;
        double y;
        double z;

        vector3f(void);
        ~vector3f(void);


        vector3f(double x_, double y_, double z_);
        void set
                (double x_, double y_, double z_);
        double length(void);
        void normalize(void);

        // Operators...
        vector3f operator + (const vector3f &other);
        vector3f operator - (const vector3f &other);
        vector3f operator * (const vector3f &other);
        vector3f operator / (const vector3f &other);

        vector3f operator * (const double scalar);
        friend vector3f operator * (const double scalar, const vector3f &other);

        vector3f& operator = (const vector3f &other);
        vector3f& operator += (const vector3f &other);
        vector3f& operator -= (const vector3f &other);

        vector3f operator + (void) const;
        vector3f operator - (void) const;

        // Static utility methods
        static double distance(const vector3f &v1, const vector3f &v2);
        static double dotProduct(const vector3f &v1,  const vector3f &v2 );
        static vector3f crossProduct(const vector3f &v1, const vector3f &v2);

};

#endif
